/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * BaseReference
 */
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "class", visible = true )
@JsonSubTypes({
  @JsonSubTypes.Type(value = ReuseReference.class, name = "ReuseReference"),
  @JsonSubTypes.Type(value = UserReference.class, name = "UserReference"),
  @JsonSubTypes.Type(value = DatasetReference.class, name = "DatasetReference"),
  @JsonSubTypes.Type(value = OrganizationReference.class, name = "OrganizationReference"),
})

public class BaseReference {
  @JsonProperty("class")
  private String propertyClass = null;

  @JsonProperty("id")
  private String id = null;

  public BaseReference propertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
    return this;
  }

   /**
   * The object class
   * @return propertyClass
  **/
  @ApiModelProperty(required = true, value = "The object class")
  public String getPropertyClass() {
    return propertyClass;
  }

  public void setPropertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
  }

  public BaseReference id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The object unique identifier
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The object unique identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BaseReference baseReference = (BaseReference) o;
    return Objects.equals(this.propertyClass, baseReference.propertyClass) &&
        Objects.equals(this.id, baseReference.id);
  }

  @Override
  public int hashCode() {
    return Objects.hash(propertyClass, id);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BaseReference {\n");

    sb.append("    propertyClass: ").append(toIndentedString(propertyClass)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

